//***************************************************************************
//
// BNDEMO3.H - Header file
//
// Steven R Clabaugh
// SRC Enterprises
//
//***************************************************************************

//***************************************************************************
//***************************************************************************
//
//  Define the application object class
//
//***************************************************************************
//***************************************************************************
class CTheApp : public CWinApp
{

   //***************************************
   // Data Members
   //***************************************

   private:

      // Window Class Name
      // Initialized by AfxRegisterWndClass call in InitApplication
      CString m_WndClassName;

   //***************************************
   // Function Members
   //***************************************

   protected:

      virtual BOOL InitApplication();
      virtual BOOL InitInstance();

}; // End Class CTheApp
//***************************************************************************
//***************************************************************************

//***************************************************************************
//***************************************************************************
//
//  Define the application's main window object class
//
//***************************************************************************
//***************************************************************************
class CMainWnd : public CFrameWnd
{

   //***************************************
   // Data Members
   //***************************************

   public:

      //************************************************************
      // Declare instances for all Buttons used on the Main Window
      //************************************************************
      CSRCEntBN
      
         // Predefined Bitmap Vertical Spin buttons(One for each Size)
         m_VSpin1, m_VSpin2, m_VSpin3, m_VSpin4, m_VSpin5, m_VSpin6,
       
         // Predefined Bitmap Horizontal Spin buttons(One for each Size)
         m_HSpin1, m_HSpin2, m_HSpin3, m_HSpin4, m_HSpin5, m_HSpin6,
       
         // 2-State Toggle Switch located directly beneath the
         // 6 vertical spin button.  It is used as a switch to enable
         // and disable the vertical spin buttons.       
         m_NFTSw,

         // This User defined Spin Button used to simulate a 2-State
         // Momentary Toggle Switch located directly beneath the 6 horizontal
         // Spin buttons.  It is used as a switch to enable and
         // disable the horizontal spin buttons.
         m_Switch1,

         // Color Buttons
         m_RedBut, m_GrnBut, m_BluBut, m_YelBut,
         m_CynBut, m_MagBut, m_GryBut, m_BlkBut,

         // Spin Button for the fancy looking Volume Control
         m_Volume,

         // 2-State Push Button That will enable and disable
         // the fancy looking Volume Control
         m_Voled;

      //************************************************************
      // Declare instances for all needed edit controls.
      // These are MFC CEdit Class.
      //************************************************************
      CEdit

         // Edit Controls for Vertcal Spin Buttons
         m_VSPEdit1, m_VSPEdit2, m_VSPEdit3,
         m_VSPEdit4, m_VSPEdit5, m_VSPEdit6,

         // Edit Controls for Horizontal Spin Buttons
         m_HSPEdit1, m_HSPEdit2, m_HSPEdit3,
         m_HSPEdit4, m_HSPEdit5, m_HSPEdit6,

         // EDIT control to display the fancy looking Volume Control value
         m_VEdit;

   CString cBuff;

   DWORD TextColor;

   //***************************************
   // Function Members
   //***************************************

   public:

      CMainWnd(CString ClassName);   // Constructor

   // *** Message Map
   protected:

      //{{AFX_MSG(CMainWnd)
      afx_msg void OnAbout();
      afx_msg int  OnCreate(LPCREATESTRUCT lpCreateStruct);
      afx_msg void OnVSpin1();
      afx_msg void OnVSpin2();
      afx_msg void OnVSpin3();
      afx_msg void OnVSpin4();
      afx_msg void OnVSpin5();
      afx_msg void OnVSpin6();
      afx_msg void OnHSpin1();
      afx_msg void OnHSpin2();
      afx_msg void OnHSpin3();
      afx_msg void OnHSpin4();
      afx_msg void OnHSpin5();
      afx_msg void OnHSpin6();
      afx_msg void OnNFTSw();
      afx_msg void OnSwitch1();
      afx_msg void OnRedBut();
      afx_msg void OnGrnBut();
      afx_msg void OnBluBut();
      afx_msg void OnYelBut();
      afx_msg void OnCynBut();
      afx_msg void OnMagBut();
      afx_msg void OnGryBut();
      afx_msg void OnBlkBut();
      afx_msg void OnVolume();
      afx_msg void OnVoled();
      afx_msg void OnPaint();      
      //}}AFX_MSG
      DECLARE_MESSAGE_MAP()     // Should be last in the class definition

}; // END Class CMainWnd
//***************************************************************************
//***************************************************************************
